/*
Titre: Exercice 03
Description: Trouver la plus petite valeur et le plus petit indice d'un tableau

Auteur: Anis Boubaker
Date: 2018-02-15
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>
#include <limits.h>

/***********CONSTANTES DE COMPILATION*************/


/********* DCLARATIONS DES FONCTION **************/
/*
Fonction: trouver_plus_petit_element
Description: Trouve la valeur du plus petit lment d'un tableau ainsi que sont indice
Arguments:
- tab (tableau d'entiers): LE tableau o on cherche le plus petit lment
- nb_elements (entier): Le nombre d'lments effectifs
- plus_petit_indice (pointeur d'entier): Adresse o sera stock l'indice du plus petit 
  lment
Paramtres modifis:
- plus_petit_indice: sa valeur sera remplace par l'indice du plus petit lment
*/
int trouver_plus_petit_element(int tab[], int nb_elements, int *plus_petit_indice);


/***************************************************************************************
*                             FONCTIONS DE TESTS                                       *
***************************************************************************************/
int test_all(void);
int test_trouver_plus_petit_element();

/*
Fonction: main
Description: 
Arguments:
- Aucuns
*/

int main(void)
{
	test_all();
	
	system("pause");
	return EXIT_SUCCESS;
}


/********* IMPLMENTATIONS DES FONCTION **************/
int trouver_plus_petit_element(int tab[], int nb_elements, int *plus_petit_indice)
{
	int i; //compteur de boucle
	int plus_petit = INT_MAX;

	//-1: valeur du + petit indice si le tableau est vide.
	*plus_petit_indice = -1;

	for (i = 0; i < nb_elements; i++)
	{
		if (tab[i] < plus_petit)
		{
			plus_petit = tab[i];
			*plus_petit_indice = i;
		}
	}

	return plus_petit;
}

int test_trouver_plus_petit_element()
{
	int tableau[5] = { 56,6,23,2,10 };
	int min,
		min_indice;

	printf("*** TEST: trouver_plus_petit_element\n");

	min = trouver_plus_petit_element(tableau, 5, &min_indice);

	if (min != 2 || min_indice != 3)
	{
		printf("*** ERREUR: Valeur min ou indice min incorrect.");
		return 0;
	}

	min = trouver_plus_petit_element(tableau, 1, &min_indice);
	if (min != 56 || min_indice != 0)
	{
		printf("*** ERREUR: Incoherence d'execution avec un tableau ayant une seule valeur.\n");
		return 0;
	}

	min = trouver_plus_petit_element(tableau, 0, &min_indice);
	if (min != INT_MAX || min_indice != -1)
	{
		printf("*** ERREUR: Incoherence d'execution avec un tableau vide.\n");
		return 0;
	}

	return 1;
}

int test_all(void)
{
	int resultats_tests = 1;

	resultats_tests = resultats_tests && test_trouver_plus_petit_element();

	if (resultats_tests)
	{
		printf("***\n*** Tous les tests se sont executes avec succes.\n***\n");
	}
	else {
		printf("***\n*** Des erreurs se sont produites lors de l'execution des tests\n***\n");
	}

	return resultats_tests;
}


