/*
Titre: Exercice04
Description: Compter le nombre d'occurences d'un lment dans un tableau

Auteur: Anis Boubaker
Date: 
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>

/***********CONSTANTES DE COMPILATION*************/


/********* DCLARATIONS DES FONCTION **************/
/*
Fonction: compter_occurences
Description: Compte le nombre d'occurences d'un lment dans un tableau
Arguments:
- tableau (tableau d'entiers): Tableau o l'on compte le nombre d'occurences
- nb_elts (entier): Nombre d'lments effectifs du tableau
- elt_a_trouver (entier): lement recherch dans le tableau
Paramtres modifis:
- Aucun
*/
int compter_occurences(int tableau[], int nb_elts, int elt_a_trouver);


/***************************************************************************************
*                             FONCTIONS DE TESTS                                       *
***************************************************************************************/
int test_all(void);
int test_compter_occurences(void);

/*
Fonction: main
Description: 
Arguments:
- Aucuns
*/

int main(void)
{
	test_all();

	system("pause");
	return EXIT_SUCCESS;
	
}


/********* IMPLMENTATIONS DES FONCTION **************/
int compter_occurences(int tableau[], int nb_elts, int elt_a_trouver)
{
	int i;  //Compteur de boucle
	int nb_occurences = 0; //Stocke le nombre d'occurences de elt_a_trouver

	for (i = 0; i < nb_elts; i++)
	{
		if (tableau[i] == elt_a_trouver)
		{
			nb_occurences++;
		}
	}
	return nb_occurences;
}

int test_compter_occurences(void)
{
	int tab[5] = { 10, 34, 2, 78, 10 };
	int occurences;

	printf("*** TEST: compter_occurences\n");

	occurences = compter_occurences(tab, 5, 10);
	if (occurences != 2)
	{
		printf("*** ERREUR: Erreur de calcul du nombre d'occurence. Attendu: 2, Obtenu: %d.\n", occurences);
		return 0;
	}

	occurences = compter_occurences(tab, 0, 10);
	if (occurences != 0)
	{
		printf("*** ERREUR: Erreur de calcul du nombre d'occurence avec tableau vide.\n");
		return 0;
	}

	occurences = compter_occurences(tab, 5, -1);
	if (occurences != 0)
	{
		printf("*** ERREUR: Erreur de calcul du nombre d'occurence avec valeur inexistante.\n");
		return 0;
	}

	return 1;
}

int test_all(void)
{
	int resultats_tests = 1;

	resultats_tests = resultats_tests && test_compter_occurences();

	if (resultats_tests)
	{
		printf("***\n*** Tous les tests se sont executes avec succes.\n***\n");
	}
	else {
		printf("***\n*** Des erreurs se sont produites lors de l'execution des tests\n***\n");
	}

	return resultats_tests;
}