/*
Titre: Exercice 01
Description: Programme simple qui porte sur la cration d'un tablau  une dimension, son 
initialisation et la dfinition des ses valeurs 

Auteur: Anis Boubaker
Date: 2018-02-15
*/

/***********COMMANDES PRPROCESSEUR*************/
#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>

/***********CONSTANTES DE COMPILATION*************/
#define TAILLE_MAX_TABLEAU 40

/***************************************************************************************
*                              PROTOTYPES DE FONCTIONS                                  *
***************************************************************************************/
/*
* FONCTION: nb_aleatoire
* Cette fonction retourne une valeur alatoire dans l'intervalle entier
[min, max]. Chaque valeur possde la mme probabilit d'tre gnre.

PARAMTRES :
- min : La plus petite valeur pouvant tre gnre (type : int).
- max : La plus grande valeur pouvant tre gnre (type : int).

VALEUR DE RETOUR : Une valeur se trouvant dans l'intervalle
[min, max]  (type : int).

ANTECEDENTS :
- On suppose que la fonction srand a pralablement t appele.
*/
int nb_aleatoire(int min, int max);


/*
Fonction: main
*/

int main(void)
{
	//dclaration de variables
	int tableau[TAILLE_MAX_TABLEAU] = { 0 };
	int i;

	//Initialisation du moteur de nombres alatoires avant d'appeler nb_aleatoire
	srand((unsigned int)time(NULL));
	rand();

	for (i = 0; i < TAILLE_MAX_TABLEAU; i++)
	{
		tableau[i] = nb_aleatoire(0, 100);
	}

	printf("Contenu du tableau: \n");
	for (i = 0; i < TAILLE_MAX_TABLEAU; i++)
	{
		printf("[%d]=%d \n",i,tableau[i]);
	}

	system("pause");
	return EXIT_SUCCESS;
}


/********* IMPLMENTATIONS DES FONCTION **************/
int nb_aleatoire(int min, int max)
{
	return min + (int)(rand() / (RAND_MAX + 0.001) * (max - min + 1));
}